if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then
   return
end

------------------------------------------------------------------------

ThreeRuneBars = CreateFrame("frame", nil, UIParent);

function ThreeRuneBars:init()
	self.isLocked = true;

	self:RegisterEvent("ADDON_LOADED");

	self:SetScript("OnEvent", function(frame, event, ...) frame[event](frame, ...); end );
	
end

function ThreeRuneBars:Unlock()
	DEFAULT_CHAT_FRAME:AddMessage("ThreeRuneBars Unlocked");
	self.isLocked = false;
	
	for name, m in pairs(self.modules) do
		if( m.moveFrame ) then
			m.moveFrame:Show();
		end
	end
end

function ThreeRuneBars:Lock()
	DEFAULT_CHAT_FRAME:AddMessage("ThreeRuneBars Locked");
	self.isLocked = true;
	for name, m in pairs(self.modules) do
		if( m.moveFrame ) then
			m.moveFrame:Hide();
		end
	end
end

function ThreeRuneBars:RegisterModule(name, m)

	if( not self.modules ) then self.modules = {}; end
	
	if( not self.modules[name]) then 
		self.modules[name] = m;
	else
		DEFAULT_CHAT_FRAME:AddMessage("UT: Module "..name.." already registered");
	end
end

function ThreeRuneBars:ChangeScale(value)
	for name, m in pairs(self.modules) do
		if (name ~= "Options") then
			m:SetScale(value);
		end
	end
end

function ThreeRuneBars:StartModules()
	for name, m in pairs(self.modules) do
		if( not (TRB_Config.disabled_modules and TRB_Config.disabled_modules[name] and TRB_Config.disabled_modules[name] == true) ) then
			--DEFAULT_CHAT_FRAME:AddMessage("ThreeRuneBars loading module: "..name);
			m:init();
			m:LoadPosition();
		else
			if(m.isRunning) then
				m:Disable(); -- Disable module if it's running.
			end
		end
	end
end

function ThreeRuneBars:ADDON_LOADED(addon)
	if( addon == "ThreeRuneBars" and (select(2, UnitClass("player")) == "DEATHKNIGHT")) then
		DEFAULT_CHAT_FRAME:AddMessage("ThreeRuneBars loaded");
		
		if( self.Options ) then
			self.Options:init();	-- Initialize TRB's Option frame and LoadConfig
		end
		
--		self:StartModules();
		
		-- Update user scale settings
		if( TRB_Config.Scale ) then
			self:ChangeScale(TRB_Config.Scale);
		end
	end
end

-- Start Addon
ThreeRuneBars:init();
